diff --git a/arch/x86/kvm/vmx.c b/arch/x86/kvm/vmx.c
index dfce28498636..1847000fbb0c 100644
--- a/arch/x86/kvm/vmx.c
+++ b/arch/x86/kvm/vmx.c
@@ -4050,17 +4050,17 @@ static void free_kvm_area(void)
 	}
 }
 
-enum vmcs_field_type {
-	VMCS_FIELD_TYPE_U16 = 0,
-	VMCS_FIELD_TYPE_U64 = 1,
-	VMCS_FIELD_TYPE_U32 = 2,
-	VMCS_FIELD_TYPE_NATURAL_WIDTH = 3
+enum vmcs_field_width {
+	VMCS_FIELD_WIDTH_U16 = 0,
+	VMCS_FIELD_WIDTH_U64 = 1,
+	VMCS_FIELD_WIDTH_U32 = 2,
+	VMCS_FIELD_WIDTH_NATURAL_WIDTH = 3
 };
 
-static inline int vmcs_field_type(unsigned long field)
+static inline int vmcs_field_width(unsigned long field)
 {
 	if (0x1 & field)	/* the *_HIGH fields are all 32 bit */
-		return VMCS_FIELD_TYPE_U32;
+		return VMCS_FIELD_WIDTH_U32;
 	return (field >> 13) & 0x3 ;
 }
 
@@ -4098,7 +4098,7 @@ static void init_vmcs_shadow_fields(void)
 
 		clear_bit(field, vmx_vmwrite_bitmap);
 		clear_bit(field, vmx_vmread_bitmap);
-		if (vmcs_field_type(field) == VMCS_FIELD_TYPE_U64) {
+		if (vmcs_field_width(field) == VMCS_FIELD_WIDTH_U64) {
 			clear_bit(field + 1, vmx_vmwrite_bitmap);
 			clear_bit(field + 1, vmx_vmread_bitmap);
 		}
@@ -4107,7 +4107,7 @@ static void init_vmcs_shadow_fields(void)
 		unsigned long field = shadow_read_only_fields[i];
 
 		clear_bit(field, vmx_vmread_bitmap);
-		if (vmcs_field_type(field) == VMCS_FIELD_TYPE_U64)
+		if (vmcs_field_width(field) == VMCS_FIELD_WIDTH_U64)
 			clear_bit(field + 1, vmx_vmread_bitmap);
 	}
 }
@@ -7751,17 +7751,17 @@ static inline int vmcs12_read_any(struct kvm_vcpu *vcpu,
 
 	p = ((char *)(get_vmcs12(vcpu))) + offset;
 
-	switch (vmcs_field_type(field)) {
-	case VMCS_FIELD_TYPE_NATURAL_WIDTH:
+	switch (vmcs_field_width(field)) {
+	case VMCS_FIELD_WIDTH_NATURAL_WIDTH:
 		*ret = *((natural_width *)p);
 		return 0;
-	case VMCS_FIELD_TYPE_U16:
+	case VMCS_FIELD_WIDTH_U16:
 		*ret = *((u16 *)p);
 		return 0;
-	case VMCS_FIELD_TYPE_U32:
+	case VMCS_FIELD_WIDTH_U32:
 		*ret = *((u32 *)p);
 		return 0;
-	case VMCS_FIELD_TYPE_U64:
+	case VMCS_FIELD_WIDTH_U64:
 		*ret = *((u64 *)p);
 		return 0;
 	default:
@@ -7778,17 +7778,17 @@ static inline int vmcs12_write_any(struct kvm_vcpu *vcpu,
 	if (offset < 0)
 		return offset;
 
-	switch (vmcs_field_type(field)) {
-	case VMCS_FIELD_TYPE_U16:
+	switch (vmcs_field_width(field)) {
+	case VMCS_FIELD_WIDTH_U16:
 		*(u16 *)p = field_value;
 		return 0;
-	case VMCS_FIELD_TYPE_U32:
+	case VMCS_FIELD_WIDTH_U32:
 		*(u32 *)p = field_value;
 		return 0;
-	case VMCS_FIELD_TYPE_U64:
+	case VMCS_FIELD_WIDTH_U64:
 		*(u64 *)p = field_value;
 		return 0;
-	case VMCS_FIELD_TYPE_NATURAL_WIDTH:
+	case VMCS_FIELD_WIDTH_NATURAL_WIDTH:
 		*(natural_width *)p = field_value;
 		return 0;
 	default:
@@ -7813,17 +7813,17 @@ static void copy_shadow_to_vmcs12(struct vcpu_vmx *vmx)
 
 	for (i = 0; i < num_fields; i++) {
 		field = fields[i];
-		switch (vmcs_field_type(field)) {
-		case VMCS_FIELD_TYPE_U16:
+		switch (vmcs_field_width(field)) {
+		case VMCS_FIELD_WIDTH_U16:
 			field_value = vmcs_read16(field);
 			break;
-		case VMCS_FIELD_TYPE_U32:
+		case VMCS_FIELD_WIDTH_U32:
 			field_value = vmcs_read32(field);
 			break;
-		case VMCS_FIELD_TYPE_U64:
+		case VMCS_FIELD_WIDTH_U64:
 			field_value = vmcs_read64(field);
 			break;
-		case VMCS_FIELD_TYPE_NATURAL_WIDTH:
+		case VMCS_FIELD_WIDTH_NATURAL_WIDTH:
 			field_value = vmcs_readl(field);
 			break;
 		default:
@@ -7861,17 +7861,17 @@ static void copy_vmcs12_to_shadow(struct vcpu_vmx *vmx)
 			field = fields[q][i];
 			vmcs12_read_any(&vmx->vcpu, field, &field_value);
 
-			switch (vmcs_field_type(field)) {
-			case VMCS_FIELD_TYPE_U16:
+			switch (vmcs_field_width(field)) {
+			case VMCS_FIELD_WIDTH_U16:
 				vmcs_write16(field, (u16)field_value);
 				break;
-			case VMCS_FIELD_TYPE_U32:
+			case VMCS_FIELD_WIDTH_U32:
 				vmcs_write32(field, (u32)field_value);
 				break;
-			case VMCS_FIELD_TYPE_U64:
+			case VMCS_FIELD_WIDTH_U64:
 				vmcs_write64(field, (u64)field_value);
 				break;
-			case VMCS_FIELD_TYPE_NATURAL_WIDTH:
+			case VMCS_FIELD_WIDTH_NATURAL_WIDTH:
 				vmcs_writel(field, (long)field_value);
 				break;
 			default: